

    GLIB 1.0                                                 19.04.92


    ABOUT

    GLib is a GRASP file librarian. It can extract files from a GRASP
    archive, add files, delete, and can be used to create archives
    that are in an Amiga friendly format. This program requires KS2.0
    to run.

    GLib is one of four components in the GL 2.0 system. The others
    are the player GL, the .PIC/.CLP converter pic2hl, and some
    external package for converting MS-DOS pictures to an Amiga
    format. The pic2hl program is written to work with HamLab 1.1 and
    Wasp 1.24.

    GLib's function is to dismantle PC format .GL files, and to
    create Amiga format .GL files that the player program can play.

    GLib is Copyright  1992 by John Bickers.


    NOTES

    This is a CLI program. Do not try to start it from Workbench.

    The following libraries are required.

            ilbm.library
            pattern.library

    In addition, the xpkmaster.library is strongly recommended, and
    may be required for some files.

    The interface to this program is meant to be like an archiver's.
    So it has a format like:

        "glib <switches> <command> <archive name> <file list>"

    Typing "GLib ?" will display a summary of the switches and commands
    available. This output looks like:

> USAGE: glib [-switches] [command] {GL file} [filelist]
>    switches: -a        Create an Amiga archive (use with 'a' command).
>              -hnum     Allow for num header records.
>              -iname    Use name as input file prefix.
>              -oname    Use name as output file prefix.
>              -tname    Use name as temp directory prefix.
>              -xmethod  Use method for xpk compression [NUKE].
>    command:  a[!]      Add [overwrite].
>              d         Delete.
>              l,v       List contents.
>              e,x       Extract.
>    filelist: a list of filenames. A name preceded by an '@' is assumed to
>              contain a list of files itself.


    SWITCHES

    -a      When used with the "a" command to create a new archive,
            this option adds a four byte header to the front of the
            file that marks it as an Amiga .GL.

            Amiga .GLs treat ILBM pictures specially. When adding,
            ILBM files are detected and converted into a compressed
            form using the xpk libraries. When extracting, the
            compressed form is unpacked into an ILBM file.

            I have found that the ilbm.library returns an error code
            -7 on some pictures generated by Wasp. I'm not sure why
            this is - my solution has been to load the offending
            picture into DPaint, then save it back out. If the
            picture is not a full screen, you can preserve the
            picture size by saving it as a brush.

    -hnum   A buffer is allocated with one entry for each file that
            can be in a .GL. The default size is 128. If you have a
            .GL with more than 128 files in it, use this switch to
            increase the buffer size.

    -iname  This option affects the 'a' command. When a file is being
            added, it's name is checked for ':' and '/' characters.
            If there are none, then any prefix specified with the -i
            switch is prepended to the filename, with a '/' if
            necessary.

            For example, if you wanted to add all the .PIC and .CLP
            files in gfx:pictures/1 to the .GL file ram:test.GL, you
            could type:

            3> glib -igfx:pictures/1 a ram:test *.PIC *.CLP

    -oname  This option affects the 'e' and 'x' commands. All
            extracted files will be saved into the directory
            specified by "name".

            For example, to extract all the .PIC files in ram:test.GL
            to ram:, you could type:

            3> glib -oram: x ram:test.GL *.PIC

    -tname  When adding or extracting files, a temporary copy of the
            .GL file is made. This switch lets you indicate where you
            want this to happen. The default temporary directory is
            "t:".

            You can save yourself a final copy from the temp file to
            the target archive name if you set this to be on the same
            volume that the target archive name is on.

    -xmethod
            Define the xpk compression method to use. The
            decompression process automatically selects which method
            to use, but for compression when adding files, you can
            select a method using this switch. The default method is
            NUKE.

            Because it has good compression and a fast decompression
            speed, NUKE is probably the best choice for archives that
            you distribute. However, when testing you might like to
            use a method that has a quicker compression speed, like
            NONE.

            GLib uses RAM to RAM xpk compression, and in very early
            releases of the xpk libraries this feature was broken.
            The xpk library would return an error code of 4. In order
            to get around this, you can use the "-x" option without
            giving a method. This will turn off xpk compression, and
            the data will be stored in raw form. Even in raw form,
            many Amiga .GL files turn out to be smaller than the
            MS-DOS originals. This is primarily because the MS-DOS
            data is 8-bit while the Amiga data is less.


    COMMANDS

    a[!]    The add command, with an optional "override" parameter.
            The files listed in the arguments are added to the
            archive. Any path prefix is removed from the filename
            when it is stored.

            If a file already exists in the archive, it will be
            skipped, unless you add the ! character to the command.
            For example, if you want to overwrite the file anim.txt
            in anim.GL, you can type:

            3> glib a! anim.GL anim.txt

            The new files are added to the archive header, then the
            archive is written out again. If all is successful, the
            old archive will be deleted (if there was one) and the
            new archive will take its place.

            If this is an Amiga archive, ILBM files being added will
            be converted to a raw form then compressed using the xpk
            libraries.

    d       The delete command. The filenames on the command line
            will be deleted from the archive.

            Matching filenames are removed from the archive header,
            and the archive is written out. If all is successful, the
            old archive will be deleted and the new archive will take
            its place.

    l,v     The list command. This lists the names and positions of
            the files in the archive.

    e,x     The extract command. The filenames on the command line
            will be extracted. If you used the -o switch, they will
            be saved to the directory you specified there. Otherwise
            they are saved to the current directory.

            If this is an Amiga archive, ILBM files being extracted
            will be decompressed using the xpk libraries, then saved
            out as IFF ILBMs.


    FILE LIST

    The arguments following the command and the archive name that do
    not start with a '-' character are treated as filenames. Wildcard
    expansion is performed for all commands.

    When a filename starts with '@', it is treated as a special case.
    The file is opened, and each line in the file is treated as a
    filename. The process is not recursive - if a filename WITHIN an
    @ file starts with a '@', it is not treated especially. Within
    the file, leading blanks are removed, and blank lines and lines
    starting with '#' are ignored.

    @ can be used to read filenames from the console, by using @* as
    an argument. For example:

    3> glib a ram:test.GL @*

    Hit Ctrl-\ to terminate the input. Note that this does NOT work
    at the end of a pipe. Opening "*" is like opening stderr. So, for
    example, the following will NOT work:

    3> list ram:#?[1-6].PIC sort quick nohead | glib a ram:test.gl @*


    CREDITS

    GLib is written by John Bickers using SAS C 5.10a.

    Scott Corley and David Yee provided sample files and other useful
    information.

    GRASP is a product of Microtex Industries, Inc. It's a sort of
    slideshow animation program on PClones.

    HamLab 1.1 is an image conversion utility by Ed Hanway. It has an
    Intuition interface, and does excellent HAM conversion with ease.

    Wasp 1.24 is basically Wasp 1.23 by Steven Reiz, to which I have
    added some code to do palette locking. It can output in LORES,
    which makes it very handy for animations that aren't too
    colorful.

    Jeff Glatt's ilbm.library is used for loading and saving ILBM
    files. See notes above about on occasional -7 error loading some
    files.

    Pattern matching is done through pattern.library, which is
    Copyright (c) Angela Schmidt.

    The xpkmaster.library and sublibraries are the work of U. Dominik
    Mueller and crew. The BLZW method, which I first saw in the form
    of compress.library, is the reason I thought about using a
    library to do compression.


    DISTRIBUTION

    GLib is Copyright  1992 by John Bickers.

    Distribution is via normal channels. That is, distribute it for
    free, or for Fred Fish like costs, but not more. And remember to
    include the documentation.


    CONTACT INFO

    If you have suggestions or problems, or want to move data, I can
    be reached at:

        John Bickers
        214 Rata St
        Naenae 6301
        New Zealand

    Or: jbickers@templar.actrix.gen.nz


    DISCLAIMER

    It works on my machine.
